unit PTR;
{Operate Trend paper tape reader on LPT1:}
{Port bit allocations
Write :
Port_base     : D0 - select nybble to read (1 = high nybble)
                D1 - direction (1=reverse)
Port_base + 2 : D0 - Pulse to step reader
Read  :
Port_base + 1 : D3 - Reader ready (1 = ready)
                D4-D7 - Nybble read }

interface
function read_no_skip : byte;
{Read 1 byte from the PTR without stepping it}
function read_ptr (direction:integer) : byte;
{Read 1 byte from the PTR, and move the tape. Set direction
 to 0 for forward (R-L) movement, 1 for reverse (L-R) movement}

implementation

const Port_base = $378; {Address of PTR port}

function read_no_skip : byte;
{Read one byte from the PTR without stepping it}
var character : byte;
begin;
  port[Port_base] := 0; {select low nybble}
  character := (port[Port_base+1] and $f0) shr 4;
  port[Port_base] := 1; {Select high nybble}
  character := character OR (port[Port_base+1] and $f0);
  read_no_skip := not (character);
end;

function read_ptr(direction:integer) : byte;
{Step the PTR, and read the next byte from it}
begin;
  port[port_base] := 2 * (direction and 1) ; {select direction}
  port[port_base+2] := 1;   {Pulse step line}
  port[port_base+2] := 0;
  repeat;
    {Wait for ready signal}
  until (port[port_base+1] and 8) > 0;
  read_ptr:=read_no_skip;
end;

end.
